print(format("CustomBars AddOn loaded, version %s", GetAddOnMetadata("CustomBars", "Version") ))

local RGBA = {
	["default"] = {1.0, 1.0, 1.0, 0.1},
	["yellow"] = {1.0, 1.0, 0, 1.0},
	["silver"] = {238/256, 238/256, 238/256, 1.0},
	["grey"] = {128/256, 128/256, 128/256, 1.0},
	["green"] = {0/256, 166/256, 31/256, 1.0},
	["red"] = {1, 0, 0, 1},
	["purple"] = {1,0,1,1},
	["orange"] = {1, 0.5, 0, 1},
	["trans"] = {1, 1, 1, 0},
	["black"] = {0,0,0,1},
	["cyan"] = {0,0.5,0.5,1},
	["hCont"] = {0,0.3,0,0.7},
	["mCont"] = {0,0,0.3,0.7},
	["hUnder"] = {0,0.2,0,0.5},
	["mUnder"] = {0,0,0.2,0.5},
}

local eFrame, virgin, isSizing, x0, y0
local hCont = {}
local mCont = {}

eFrame = CreateFrame("Frame", "EventFrame", UIParent)
local eList = {
"ADDON_LOADED",
"PLAYER_ENTERING_WORLD", "UNIT_EXITING_VEHICLE", "UNIT_EXITED_VEHICLE", "ZONE_CHANGED", "ZONE_CHANGED_INDOORS", "ZONE_CHANGED_NEW_AREA"
}
for k = 1, table.getn(eList) do eFrame:RegisterEvent(eList[k]) end

local function storeVar(name, val)
	CBARS[name] = val
	return val
end

local function loadVar(name, val)
	local r12 = CBARS[name]
	if r12 ~= nil then
		return r12
	else
		return storeVar(name, val)
	end
end

local function adjustBars()
	if hCont[1] and PlayerFrameHealthBar then
		local frame = PlayerFrameHealthBar
		local point, relativeTo, relativePoint, xOffset, yOffset = hCont[1]:GetPoint()
		local width, height = hCont[1]:GetSize()
		if relativeTo ==  nil then relativeTo = hCont[1]:GetParent() end
		
		hCont[2]:ClearAllPoints()
		hCont[2]:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		hCont[2]:SetSize(width, height)
		hCont[2]:Lower()
		
		frame:ClearAllPoints()
		frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		frame:SetSize(width, height)
	end
	if mCont[1] and PlayerFrameManaBar then
		local frame = PlayerFrameManaBar
		local point, relativeTo, relativePoint, xOffset, yOffset = mCont[1]:GetPoint()
		local width, height = mCont[1]:GetSize()
		if relativeTo ==  nil then relativeTo = mCont[1]:GetParent() end
		
		mCont[2]:ClearAllPoints()
		mCont[2]:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		mCont[2]:SetSize(width, height)
		mCont[2]:Lower()
		
		frame:ClearAllPoints()
		frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
		frame:SetSize(width, height)
		if frame.FeedbackFrame then
			local subframe = frame.FeedbackFrame
			point, relativeTo, relativePoint, xOffset, yOffset = subframe:GetPoint()
			subframe:SetPoint(point, relativeTo, relativePoint, xOffset, 0)
			subframe:SetSize(width, height)
		end
		if frame.FullPowerFrame then 
			local subframe = frame.FullPowerFrame
			subframe:SetHeight(height)
			subframe.PulseFrame:SetHeight(height)
			subframe.SpikeFrame:SetHeight(height)
			height = height * 1.5
			subframe.SpikeFrame.AlertSpikeStay:SetHeight(height)
			subframe.SpikeFrame.BigSpikeGlow:SetHeight(height)
			height = height * 1.05
			subframe.PulseFrame.SoftGlow:SetHeight(height)
			subframe.PulseFrame.YellowGlow:SetHeight(height)
		end
	end
end

local function storeCont(cont)
	local point, relativeTo, relativePoint, xOffset, yOffset = cont:GetPoint()
	local width, height = cont:GetSize()
	if relativeTo ==  nil then relativeTo = cont:GetParent() end
	local contState = {point, relativeTo:GetName(), relativePoint, xOffset, yOffset,width,height}
	storeVar(cont.prf, contState)
end

local function resizeCont(cont)
	local cx, cy = GetCursorPosition()
	local dx, dy = cx - x0, cy - y0
	if dx ~= 0 or dy ~= 0 then
		local width, height = cont:GetSize()
		local nw, nh = width + dx, height + dy
		if nw > 20 and nh > 15 then
			cont:SetSize(nw,nh)
			x0 = cx
			y0 = cy
		end
	end
end

local function onMouseDown(self, button)
	if button == "LeftButton" then
		if not self.isMoving then
			self:StartMoving()
			self.isMoving = true
		end
		
	elseif button == "RightButton" then
		if not self.isSizing then
			self.isSizing = true
			isSizing = self
			x0, y0 = GetCursorPosition()
		end	
	end
end

local function onMouseUp(self, button)
	if button == "LeftButton" then
		if self.isMoving then
			self:StopMovingOrSizing()
			self.isMoving = false
			storeCont(self)
			adjustBars()
		end
	
	elseif button == "RightButton" then
		if self.isSizing then
			self:StopMovingOrSizing()
			self.isSizing = false
			isSizing = nil
			storeCont(self)
			adjustBars()
		end	
	end
end

local function makeFrame(name, par, w, h, x, y, aself, apar, flag_tex, clr, clamped, enabled, movable, rezable, prefix, strata)
	local obj = CreateFrame("Frame", name, par)
	obj:SetFrameStrata(strata)
	obj:SetPoint(aself, par, apar, x, y)
	obj:SetSize(w, h)
	if flag_tex then
		local tex = obj:CreateTexture("tex", strata)
		if clr ~= nil then
			tex:SetColorTexture(unpack(RGBA[clr]))
		else
			tex:SetColorTexture(unpack(RGBA["default"]))
		end
		tex:SetAllPoints(obj)
		obj.tex = tex
	end
	obj:SetClampedToScreen(clamped)
	obj:EnableMouse(enabled)
	obj:SetMovable(movable)
	obj:SetResizable(rezable)
	if enabled then
		obj:SetScript("OnMouseDown", onMouseDown)
		obj:SetScript("OnMouseUp", onMouseUp)
		obj.isMoving = false
		obj.isSizing = false
	end
	obj.prf = prefix
	return obj
end

local function createCont(prefix,clr)
	local default = {}
	if prefix == "hCont" then
		default = {"TOP","UIParent","CENTER",0,-80,300,20}
	elseif prefix == "mCont" then
		default = {"TOP","UIParent","CENTER",0,-80-20,300,15}
	end
	local contState = loadVar(prefix,default)
	local aself, par, apar, x, y, w, h = unpack(contState)
	return makeFrame(nil, _G[par], w, h, x, y, aself, apar, true, clr, true, true, true, true, prefix, "MEDIUM")
end

local function showContainers()
	if CBARS == nil then CBARS = {} end
	if hCont[1] == nil then hCont[1] = createCont("hCont","hCont") end
	if mCont[1] == nil then mCont[1] = createCont("mCont","mCont") end
	hCont[1]:Raise()
	mCont[1]:Raise()
	hCont[1]:Show()
	mCont[1]:Show()
	if hCont[2] == nil then	hCont[2] = makeFrame(nil, UIParent, 100, 100, 0, 0, "CENTER", "CENTER", true, "hUnder", true, false, true, true, nil, "BACKGROUND") end
	if mCont[2] == nil then	mCont[2] = makeFrame(nil, UIParent, 100, 100, 0, 0, "CENTER", "CENTER", true, "mUnder", true, false, true, true, nil, "BACKGROUND") end
end

SLASH_CBARS1 = "/cbars"
function SlashCmdList.CBARS(msg, ...)
	local cmd = strsplit(" ", strlower(msg), 2)
	if cmd == "" then
		showContainers()
	elseif cmd == "on" then
		showContainers()
	elseif cmd == "off" then
		if hCont[1] then hCont[1]:Hide() end
		if mCont[1] then mCont[1]:Hide() end
	elseif cmd == "clump" then
		local point, relativeTo, relativePoint, xOffset, yOffset = hCont[1]:GetPoint()
		local width, height = hCont[1]:GetSize()
		if relativeTo ==  nil then relativeTo = hCont[1]:GetParent() end
		mCont[1]:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset - height)
		mCont[1]:SetSize(width, height)
		storeCont(mCont[1])
		adjustBars()
	elseif cmd == "force" and virgin == 0 then
		virgin = 1
	end
end

local total = 0
function eFrame:OnUpdate(elapsed)
	total = total + elapsed
	if total >= 1/20 then
		if isSizing ~= nil and PlayerFrame then
			resizeCont(isSizing)
		end
		if PlayerFrame and virgin == 1 then
			virgin = 0
			showContainers()
			adjustBars()
			hCont[1]:Hide()
			mCont[1]:Hide()
		end
		total = 0
	end
end

function eFrame:OnEvent(event, ...)
	if event == "ADDON_LOADED" then
		if select(1, ...) == "CustomBars" then
			virgin = 1
			isSizing = nil
			eFrame:SetScript("OnUpdate", eFrame.OnUpdate)
		end
	elseif virgin == 0 then
		virgin = 1
	end
end

eFrame:SetScript("OnEvent", eFrame.OnEvent)


















